#include <bits/stdc++.h>
using namespace std;

int N,M,Q;
int mat[5*10000+5][5*10000+5];
long long sum[5*10000+5][5*10000+5];
long long res;


void pocetni_ulaz(){
    scanf("%d %d",&N, &M);
    for(int i=1;i<=N;i++){
        for(int j=1;j<=M;j++){
            scanf("%d", &mat[i][j]);
        }
    }
}

void provera_pocetnog_ulaza(){
    cout << "Provera matrice:" << endl;
    for(int i=0;i<=N;i++){
        for(int j=0;j<=M;j++){
            cout << mat[i][j] << " ";
        }
        cout << endl;
    }
    cout << "Kraj provere ---"<<endl <<endl;
    
}

void predef(){
    for(int i=0;i<=M;i++){  // popuni nulti red
        sum[0][i]=1e17;
    }
    
    for(int i=1;i<=N;i++){  // popuni nultu kolonu
        sum[i][0]=1e17;
    }
    sum[1][0]=sum[0][1]=0;
}
void provera_sume(){
    cout << "Provera sume:" << endl;
    for(int i=0;i<=N;i++){
        for(int j=0;j<=M;j++){
            cout << sum[i][j] << " ";
        }
        cout << endl;
    }
    cout << "Kraj provere ---"<<endl <<endl;
}

void predefinisi_sumu(int red, int kolona){
    for(int i=1;i<=N;i++){
        for(int j=1;j<=M;j++){
            sum[i][j]=mat[i][j];
        }
    }
    sum[red][kolona]+=1e17;
    if(red==1){
        for(int i=kolona;i<=M;i++){
            sum[1][i]=1e17;
        }
    }
    if(kolona==1){
        for(int i=red;i<=N;i++){
            sum[i][1]=1e17;
        }
    }
}

long long popuni_sumu(){
    for(int i=1;i<=N;i++){
        for(int j=1;j<=M;j++){
            if(sum[i-1][j]<sum[i][j-1]){
                sum[i][j]+=sum[i-1][j];
            }
            else{
                sum[i][j]+=sum[i][j-1];
            }
        }
    }
    return sum[N][M];
}

int main(){
    pocetni_ulaz();
    //provera_pocetnog_ulaza();
    scanf("%d", &Q);

    int x,y;

    predef();

    //provera_sume();


    for(int i=1;i<=Q;i++){
        scanf("%d %d",&x,&y);

        //cout << "PRE" << endl;
        predefinisi_sumu(x,y);
        
        //cout << "POSLE" << endl;
        //provera_sume();

        printf("%lld\n",popuni_sumu());
        //cout << "KRAJ" << endl;
        //provera_sume();
        //cout << "KRAJ2" << endl;

    }

    return 0;
}